// statusbar.cpp - 'A Quest Too Far'
//
// Copyright 2010 Geoffrey White
//
// see readme.txt for more details.

#include "statusbar.h"
#include "map.h"
#include "creature.h"
#include <assert.h>

#define POISON_STYLE mk_char_style(0, 224, 0, 0, 0, 0)

void draw_status(int y, creature *_creature)
{
	char_style style;
	std::string str;

	// draw basic status bar
	str = "hp:            dmg:       dec:      item:               ";
	   // "hp: 99/99 POIS dmg: 99-99 dec: 9999 item: 99/99 DEFRPRIV"
	   //  ----------*---------*---------*---------*---------*-----
	assert(str.size() == GRID_WIDTH);
	char_draw(0, y, str, mk_char_style(192, 192, 192, 0, 0, 0));

	// fill in specifics
	if (_creature != NULL)
	{
		// hit points
		style = mk_char_style(255, 0, 0, 0, 0, 0);
		if (_creature->hp > _creature->hp_max / 3)
		{
			style = mk_char_style(255, 255, 0, 0, 0, 0);
		}
		if (_creature->hp > (_creature->hp_max * 2) / 3)
		{
			style = mk_char_style(0, 255, 0, 0, 0, 0);
		}
		char_draw(4, y, char_int_str(_creature->hp) + "/" + char_int_str(_creature->hp_max), style);

		// poisoned?
		if (_creature->poisoned_turns > 0)
		{
			char_draw(10, y, "POIS", POISON_STYLE);
		}

		// damage
		char_draw(20, y, char_int_str(_creature->damage_min) + "-" +
						 char_int_str(_creature->damage_max), char_default_style);

		// decline
		style = char_default_style;
		if (_creature->poisoned_turns > 0)
		{
			style = mk_char_style(255, 0, 0, 0, 0, 0);
		}
		char_draw(31, y, char_int_str(_creature->decline), style);

		// items
		style = char_default_style;
		if (_creature->carrying > _creature->get_carry_max())
		{
			style = mk_char_style(255, 0, 0, 0, 0, 0);
		}
		char_draw(42, y, char_int_str(_creature->carrying) + "/" + char_int_str(_creature->get_carry_max()), style);

		// flags
		if (_creature->has_detection)
		{
			char_draw(48, y, "DE", DETECTION_STYLE);
		}
		if (_creature->resists_fire)
		{
			char_draw(50, y, "FR", mk_char_style(224, 0, 0, 0, 0, 0));
		}
		if (_creature->resists_poison)
		{
			char_draw(52, y, "PR", POISON_STYLE);
		}
		if (_creature->has_invisibility)
		{
			char_draw(54, y, "IV", mk_char_style(192, 192, 192, 0, 0, 0));
		}
	}
}